/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.client.session.Session");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

(function() {

	var checkNotNull 	= net.jazz.ajax.toolbox.lang.checkNotNull;
	var checkNotEmpty 	= net.jazz.ajax.toolbox.lang.checkNotEmpty;

	function checkInit() {
		//dojo.lang.assert(typeof com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR  != "undefined", "AUTHENTICATED_CONTRIBUTOR global is not defined; workbench has not been properly initialized");
		checkNotNull(com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR, "com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR");
	}
	
	/**
	 * Returns an object representing the current logged-in contributor or the Guest contributor if not logged in.
	 * 
	 * @since 0.5
	 */
	function getAuthenticatedContributor() {
		checkInit();
		return com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR;
	}
	
	com.ibm.team.repository.web.client.session.getAuthenticatedContributor = getAuthenticatedContributor;
	
	/**
	 * Return true if the current user is logged-in (ie not Guest); false otherwise;
	 * 
	 * @since 0.5
	 */
	function isGuest() {
		checkInit();
		return com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR.itemId == "_OIi3MCDNEdu1A6FdF3RHyQ";
	}
	
	com.ibm.team.repository.web.client.session.isGuest = isGuest;


	/**
	 * Return true if the current user is logged-in as the default ADMIN user; false otherwise;
	 * 
	 * @since 0.6 M6
	 */
	function isDefaultAdmin() {
		checkInit();
		return com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR.userId == "ADMIN";
	}
	
	com.ibm.team.repository.web.client.session.isDefaultAdmin = isDefaultAdmin;
	
	/**
	 * Returns a string object of the current logged-in userId using AUTHENTICATED_CONTRIBUTOR 
	 *  if available, or whoami if available, or UNKNOWN if neither is available
	 *   
	 */
	function getAuthenticatedUserId() {
		var testAUTH = com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR;
		if (testAUTH) {
			return testAUTH.userId;
		}
		var testWhoAmI = com.ibm.team.repository.web.client.internal.AUTHENTICATED_USERID;
		if (testWhoAmI) {
			return testWhoAmI;
		}
		return "UNKNOWN";	// don't externalize this string
	}
	
	com.ibm.team.repository.web.client.session.getAuthenticatedUserId = getAuthenticatedUserId;


})();