/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.wizard.WizardIntro");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("net.jazz.ajax.ui.internal.Button");

dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.wizard", "WizardIntroMessages");

(function() {

var ServerStatusClient = com.ibm.team.repository.web.client.internal.ServerStatusClient;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var messages;

dojo.declare("com.ibm.team.repository.web.ui.internal.wizard.WizardIntro",  [dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/wizard/templates/Intro.html"),

	constructor: function() {
		this.messages = messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.wizard", "WizardIntroMessages");
	},

	postCreate: function() {
		com.ibm.team.repository.web.ui.internal.wizard.WizardIntro.superclass.postCreate.apply(this);
		this._navigation = this.wizardNav;
		this._navigation.domNode.style.display = "none";
		this._setupButtons();
		this._invokeServer();
	},
	
	_setupButtons: function() {
		var self = this;
		var args = {
			callback: function(){
				document.location.href = self.fastAction;
			},
			buttonText: this.messages.fastPathButton, 
			size: "large",
			"class":  "com-ibm-team-repository-wizard-button"
		}
		var fastButton = new net.jazz.ajax.ui.internal.Button(args);
		this._fastPathButton.appendChild(fastButton.domNode);

		args.callback = function(){
				document.location.href = self.customAction;
		},
		args.buttonText = this.messages.customButton;
		var customButton = new net.jazz.ajax.ui.internal.Button(args);
		this._customPathButton.appendChild(customButton.domNode);	
	},
	
	_invokeServer: function () {
		var srh= new ServiceResponseHandler(this, "_doNothing", "_doNothing");
		ServerStatusClient.getServiceConfiguration(srh, "com.ibm.team.repository.service.internal.MailerService");
	}, 
	
	_doNothing: function () {
		// do nothing
		// this is to activate the services on a newly started server
	}
});

})();